/*
 * NQM_StromUndSpannung.c
 *
 * Created: 14.07.2016 10:35:44
 *
 * Controller SLAVE
 */ 

// Bibliotheken

// Systembibliotheken
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdlib.h>         // noetig fr Zahlumwandlung mit itoa
#include <util/twi.h> 	    // enthaelt z.B. die Bezeichnungen fr die Statuscodes in TWSR
#include <stdint.h> 	    // definiert den Datentyp uint8_t


// eigene Bibliotheken
#include "General.h"
//#include "RS232.h"
#include "Delay.h"
#include "TWI_Slave.h"
#include "Variablen.h"

#include "TWI_Slave.c"
#include "Delay.c"





/*
* Delay-Funktionen:
* Delay_ms (10)			// Funktionsaufruf im ms-Bereich
* Delay_us (100)		// Funktionsaufruf im s-Bereich
*/



int main(void)
{
	/* Peripherie einrichten und konfigurieren */
	/* Portdefinitionen */
	DDRD = 0x00;							// als Eingang maskiert
	PORTD |= 0x00;					// Pull-down

	/* ADC-Definitionen */
	ADCSRA = (1 << ADPS1)|(1 << ADPS0);		// Vorteiler auf 8 einstellen,
											// ist das schnellst moegliche
											// das ergibt 125000Hz
											// Abtasttheorem nach Shannon erfllt
	ADCSRA = (1 << ADEN);					// ADC aktivieren
	ADMUX |= (1 << MUX0);					// zunaechst Kanal 1 waehlen
	ADMUX |= (0 << REFS1)|(1 << REFS0)|(1 << ADLAR);
											// Referenzspannung ist AVCC (5V)
											// Ergebnis im High-Teil

	/* Interruptdefinitionen */
	GICR |= (1 << INT1)|(0 << INT0);		// ext. Interrupt 1 einschalten,
											// externer Interrupt 0 noch
											// ausgeschalten lassen
	MCUCR |= (1 << ISC11)|(1 << ISC10);		// ext. Interrupt 1 auf steigende
											// Flanke maskiert

	TWIS_Init (0x50, 10000);
	



	sei();									// Interrupts freigeben
											// Interrupts sind in der gesamten
											// Laufzeit des Programms freigegeben
											// Unterbrechung nur im Sendevorgang
	Daten_bereitstellen = 0;
    while (1)
	{
		
		
/******************* Funktionen **********************************************/
/*
* Die Funktionen sind anhand der vergebenen Namen selbsterklaerend.
*/
// {
	
/******************* Messungen ***********************************************/
//		{
while (StartSpannungmessen == 1)
{
/*
* Die Spannungsmessung wird solange ausgefhrt, bis der aktuelle Wert
* vier mal kleiner war als der bisher ermittelte groeste Wert. Strom- und
* Spannungsmessung wechseln sich nach jeder Konversation ab. Erst erfolgt
* die Spannungsmessung.
*/
	GICR |= (0 << INT1)|(0 << INT0);		// ext. Interrupt 1 ausschalten,
	/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
	// Kann man IIC sperren und spter wieder freigeben?
	while (i < wie_oft_ueberschreiten) // if 
	/*
	* Diese Abfrage dient dazu, dass dieser Codeteil uebersprungen wird,
	* wenn die Ermittlung des Spitzenwertes abgeschlossen ist und nur noch die
	* Strommessung erfolgt.
	*/
	{
		ADCSRA |= (1 << ADSC);							// starte Konversation
		while (ADCSRA & (1 << ADSC));					// warte auf Ende
														// Konversation
		aktueller_spannungswert = ADCH;					// 8 Bit-Wert
	
		if (aktueller_spannungswert >= maximaler_spannungswert)
		{
			maximaler_spannungswert = aktueller_spannungswert;
			i = 0;										// sollten schon
														// hoehere Werte
														// aufgetreten sein
														// werden diese
														// zurueck gesetzt
		}
		else
		{
			i++;
		}
	}
//	if (i == wie_oft_ueberschreiten)
//	{
		z = maximaler_spannungswert;
		Daten_bereitstellen = 1;
		StartSpannungmessen = 0;
//	}
}
	
/*	
	if (StartStrommessen = 1)
	{
		ADMUX |=(0 << MUX0);							// Kanal 0 waehlen
		ADCSRA |= (1 << ADSC);							// starte Konversation
		while (ADCSRA & (1 << ADSC));					// warte auf Ende
														// Konversation
		aktueller_stromwert = ADCW;						// 10 Bit-Wert
		
		if (aktueller_stromwert >= maximaler_stromwert)
		{
			maximaler_stromwert = aktueller_stromwert;
			j = 0;										// sollten schon
														// hoehere Werte
														// aufgetreten sein
														// werden diese
														// zurueck gesetzt
		}
		else
		{
			j++;
		}
		
		if (j > 4)
		{
			StartStrommessen = 0;
		}
	
		ADMUX |= (1 << MUX0);							// Kanal wieder
														// umschalten
	}
*/

//	if ((i > 4) && (j > 4))
	/*
	* Da es sich um eine while-Schleife handelt, darf die Variable nicht eher
	* abgeschalten werden, solange noch eine von beiden Messungen nicht 
	* beendet ist, d.h. die Variable wird erst dann abgeschalten, wenn
	* wirklich beide Messungen erfolgt und beendet sind. Dann wird noch
	* schnell der Phasenwinkel bestimmt und die while-Schleife verlassen,
	* bis der Interrupt fuer die neue Messfolge schaltet.
	*/
/*	{
		//PhasenwinkelAusrechnen(tempzeit);
		phasenwinkel = 360 * 50 * (tempzeit * 0.000256);	// Umrechnung Zeit
															// in Winkel
		i = 0;
		j = 0;
		StartSpannungmessen = 0;
	} 

}
//		}
*/

/******************* Berechnungen ********************************************/
//		{
/******************* Phasenwinkel ausrechnen *********************************/
/*
void PhasenwinkelAusrechnen(int zeit)
{
//
* Die Formel lautet: phi = 360 * f * Delta_t
* phi = 360 * 50Hz * Delta_t
* Delta_t wird durch die Zeitdifferenz von Spannung und Strom ermittelt
* siehe Interrupts
* Delta_t = tempzeit * 0.000256
//	
	phasenwinkel = 360 * 50 * (zeit * 0.000256);	// Umrechnung Zeit
													// in Winkel
	tempzeit = 0;									// nicht eher 0 setzen!
}
//		}
*/

// }





/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
// Keine Ahnung ob das so richtig ist und wie ich das machen msste wenn ich mehrere Daten habe.
/******************* Kommunikation *******************************************/
// {
/*
* Fuer die Kommunikation wird der IIC- bzw. TWI-Bus verwendet. Dieser 
* Controller ist als SLAVE konfiguriert. Die Kommunikation erfolgt
* zwischen erfolgreicher Messdatenaufnahme und neuer Messwerterfassung.
*/
while (Daten_bereitstellen == 1)
{
	if (TWIS_ResonseRequired (&TWIS_ResonseType))
	{
		switch (TWIS_ResonseType)
		{
			/*
			** Slave is requested to send bytes to the master.
			** It is expliciltely assumed, that the master expects 8 bytes
			*/
			case TWIS_WriteBytes:
			
				TWIS_Write(z);
//				TWIS_Write(byte[1]);
//				printf ("Byte sent:  %d\n", j-1);
				GICR |= (1 << INT1)|(0 << INT0);		// ext. Interrupt 1 einschalten
				Daten_bereitstellen = 0;
			
			TWIS_Stop ();
			break;
		}
	}
	
}
		
		

		
	}
}

/******************* Interrupts **********************************************/
// {
/******************* externe Interrupts **************************************/
/*
* Wenn der externe Interrupt 1 gesetzt wird, wird der Timer gestartet.
* Ausgeloest wird dieser sobald die positive Halbwelle der Spannung kommt.
* Durch dieses Ereignis, wird auch die Messung der Spannung begonnen.
* Gestoppt wird der Timer, wenn der externe Interrupt 0 gesetzt wird.
* Dieser wird ausgeloest, sobald der Strom in die positive Halbwelle geht.
* Durch dieses Ereignis wird auch die Messung fuer den Strom begonnen.
*/

//		{
/* Spannung messen freigeben */
ISR (INT1_vect)
{
//	TIMSK |= (1<<TOIE0);					// Timer 0 Overflow erlaubt
//	GICR |= (1 << INT0);					// ab hier externen Interrupt 1
	// einschalten und Spannung
	// messen freigeben
	Delay_ms(3);
	StartSpannungmessen = 1;
}
/* Strom messen freigeben */
/*
ISR (INT0_vect)
{
	TIMSK |= (0 << TOIE0);					// Timer 0 Overflow geschlossen
	GICR |= (0 << INT1);					// ab hier externen Interrupt 1
	// wieder ausschalten, erst wieder
	// auf Spannung warten!
	StartStrommessen = 1;					// Strom messen freigeben
}
//		}
*/

/******************* Timer ***************************************************/
/*
* Der Timer zaehlt die Variable "tempzeit" alle 0,256ms hoch. Diese kann
* dann direkt fuer die Umrechnung verwendet werden.
*/

//		{
	/*
ISR (TIMER0_OVF_vect)
{
	tempzeit++;								// spaeter mit 0,000256s
	// multiplizieren!
	// hier nur Variable die hoch
	// gezaehlt wird alle 0,256ms
}

//		}

// }
*/